package me.hammerle.code;

import java.util.Collection;
import java.util.HashMap;
import me.hammerle.scheduler.SnuviScheduler;

public class ScriptControl
{
    private static int idCounter = 0;
    private final static HashMap<Integer, Script> SCRIPTS = new HashMap<>();
    
    // -------------------------------------------------------------------------
    // Script - Verwaltung
    // -------------------------------------------------------------------------

    public static Script getScript(int id)
    {
        return SCRIPTS.get(id);
    }
    
    public static void term(Script sc)
    {
        if(sc == null)
        {
            return;
        }
        sc.setInvalid();
        sc.closeFrame();
        SnuviScheduler.doScheduledTask(() -> SCRIPTS.remove(sc.getId()));
    }
    
    public static void termScripts()
    {
        SCRIPTS.values().forEach(sc -> 
        {
            sc.setInvalid();
            sc.closeFrame();
        });
        SnuviScheduler.doScheduledTask(() -> SCRIPTS.clear());
    }
    
    public static Collection<Script> getScripts()
    {
        return SCRIPTS.values();
    }
    
    // -----------------------
    // Scripts laden und starten
    // -----------------------
  
    public static void startScriptFromFile(String scriptName)
    { 
        Script sd = new Script(idCounter, scriptName, String.join("\n", ScriptUtils.readCode(scriptName)));
        SCRIPTS.put(idCounter, sd);
        idCounter++;
        sd.runCode();
    }
    
    public static void startScriptFromCode(String code)
    { 
        Script sd = new Script(idCounter, "CONSOLE-" + idCounter, code);
        SCRIPTS.put(idCounter, sd);
        idCounter++;
        sd.runCode();
    }
}
