package me.hammerle.console;

import java.awt.Color;
import java.awt.Font;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import me.hammerle.scheduler.SnuviScheduler;

public class BlackBox extends JScrollPane
{
    private final StyledDocument doc;
    protected final JTextPane area;
    protected final Console c;
    
    public BlackBox(Console c)
    {
        this.c = c;
        
        area = new JTextPane();
        //area.setLineWrap(true);
        area.setBackground(Color.black);
        area.setFont(new Font("Monaco", Font.PLAIN, 14));
        area.setForeground(Color.white);
        area.setCaretColor(Color.white);
        area.setAutoscrolls(true);
        /*area.selectAll();
        MutableAttributeSet set = new SimpleAttributeSet(area.getParagraphAttributes());
        StyleConstants.setLineSpacing(set, -0.17f);
        area.setParagraphAttributes(set, true);*/
        
        super.setViewportView(area);
        super.setBackground(Color.black);
        super.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        
        doc = area.getStyledDocument();
    }
    
    public void insert(String s, Color c, int pos)
    {
        Style style = null;
        if(c != null)
        {
            style = doc.getStyle(s);
            if(style == null)
            {
                style = area.addStyle(c.toString(), null);
                StyleConstants.setForeground(style, c);
                /*StyleConstants.setLineSpacing(style, 0);
                StyleConstants.setSpaceAbove(style, 20);
                StyleConstants.setSpaceBelow(style, 0);*/
            }
        }
        try 
        {
            doc.insertString(pos, s, style);
        } 
        catch (BadLocationException ex) 
        {
        }
    }
    
    public void append(String s, Color c)
    {
        insert(s, c, doc.getLength());
    }
    
    public void insertAtCaret(String s, Color c)
    {
        insert(s, c, area.getCaretPosition());
    }
    
    protected void scrollToBottom()
    {
        JScrollBar v = this.getVerticalScrollBar();
        v.setValue(v.getMaximum());
    }
}
