package me.hammerle.graphics;

import java.awt.Color;
import java.awt.Graphics;
import java.util.TreeMap;
import javax.swing.JPanel;

public class GraphicPanel extends JPanel
{
    private final TreeMap<Integer, Graphic> objects;
    
    public GraphicPanel()
    {
        this.objects = new TreeMap<>();
        super.setBackground(Color.black);
    }
    
    public synchronized Graphic getGraphic(int id)
    {
        return objects.get(id);
    }
    
    public synchronized void removeGraphic(int id)
    {
        objects.remove(id);
    }
    
    public synchronized void addGraphic(int id, Graphic g)
    {
        objects.put(id, g);
    }

    @Override
    public synchronized void paint(Graphics g) 
    {
        super.paint(g);
        objects.values().forEach(go -> 
        {
            if(go.hasColor())
            {
                g.setColor(((Colorable) go).getColor());
            }
            go.paint(g);
        });
    }   
}
